Const HKEY_LOCAL_MACHINE = &H80000002
Dim WshShell
Set WshShell = CreateObject("WScript.Shell")
Dim verbose
verbose = 1

Set objFSO = CreateObject("Scripting.FileSystemObject")

If not objFSO.FileExists("C:\Windows\System32\igfxcfg.exe") Then
	If verbose Then Wscript.Echo "No Intel graphics installed"
	Wscript.Quit
End If

userkey="HKEY_CURRENT_USER"
' look for igfx being used
Dim objRegistry

Set objRegistry = GetObject("winmgmts://./root/default:StdRegProv")

igfxused  = 0
maxdev = WshShell.RegRead("HKLM\HARDWARE\DEVICEMAP\VIDEO\MaxObjectNumber")
For n = 0 To maxdev
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, "HARDWARE\DEVICEMAP\VIDEO", "\Device\Video" & n, dev
	If lcase(left(dev, 18)) = "\registry\machine\" And right(dev, 5) = "\0000" Then
		key = "HKLM\" & mid(dev, 19, len(dev)-23) & "\Video\Service"
		driver = WshShell.RegRead(key)
		if driver = "igfx" Then igfxused = 1
	End If

Next
If igfxused = 0 Then
	If verbose Then wscript.echo "Intel Graphics not in use"
	Wscript.quit
End If

xres = 1024
yres = 768
mode = readPersonality("displaymode")
pres = readPersonality("resolution")
xpos = instr(pres, "x")
if xpos > 0 Then
	persx = 0
	persy = 0
	On Error resume Next
	persx = cint(left(pres, xpos-1))
	persy = cint(mid(pres, xpos+1))
	On Error Goto 0
	
	if persx > 0 And persy > 0 Then
		xres = persx
		yres = persy
	End If
End If

Set objArgs = WScript.Arguments

If objArgs.Count > 1 Then
	xres = objArgs(0)
	yres = objArgs(1)
	opmode = 1
End If
If objArgs.Count > 2 Then mode = objArgs(2)

Wscript.echo xres & "x" & yres
' 1 = single
' 4 = clone
' 8 = extend
opmode = 1
If mode = "clone" Then opmode = 4
If mode = "extend" Then opmode = 8


scheme = "pvs"
root = userkey & "\Software\Intel\Display\igfxcui\schemes\" & scheme & "\"
WshShell.RegWrite root & "schemeexe", "", "REG_SZ"
WshShell.RegWrite root & "szaspect", 2, "REG_DWORD"
WshShell.RegWrite root & "szbblue", 0, "REG_DWORD"
WshShell.RegWrite root & "szbgreen", 0, "REG_DWORD"
WshShell.RegWrite root & "szbpp", 32, "REG_DWORD"
WshShell.RegWrite root & "szbred", 0, "REG_DWORD"
WshShell.RegWrite root & "szcblue", &H32&, "REG_DWORD"
WshShell.RegWrite root & "szcgreen", &H32&, "REG_DWORD"
WshShell.RegWrite root & "szcred", &H32&, "REG_DWORD"
WshShell.RegWrite root & "szgblue", &H10&, "REG_DWORD"
WshShell.RegWrite root & "szggreen", &H10&, "REG_DWORD"
WshShell.RegWrite root & "szgred", &H10&, "REG_DWORD"

WshShell.RegWrite root & "szsaspect", 2, "REG_DWORD"
WshShell.RegWrite root & "szsbblue", 0, "REG_DWORD"
WshShell.RegWrite root & "szsbgreen", 0, "REG_DWORD"
WshShell.RegWrite root & "szsbpp", 32, "REG_DWORD"
WshShell.RegWrite root & "szsbred", 0, "REG_DWORD"
WshShell.RegWrite root & "szscblue", &H32&, "REG_DWORD"
WshShell.RegWrite root & "szscgreen", &H32&, "REG_DWORD"
WshShell.RegWrite root & "szscred", &H32&, "REG_DWORD"
WshShell.RegWrite root & "szsgblue", &H10&, "REG_DWORD"
WshShell.RegWrite root & "szsggreen", &H10&, "REG_DWORD"
WshShell.RegWrite root & "szsgred", &H10&, "REG_DWORD"

' DVI output is limited to 1024x768
secx=1024
secy=768

' device 1 = VGA
' device 0x1000 = DVI
' device 0 = disabled (must disable unused devices)
secdev = &H1000&
If opmode = 1 Then secdev = 0
If opmode = 4 Then
	If xres > 1024 Or yres > 768 Then
		xres = 1024
		yres = 768
	End If
	secx = xres
	secy = yres
End If

' Get current resolution
Set wmiObjSet2 = GetObject("winmgmts:{impersonationLevel=impersonate}"). _
	InstancesOf("Win32_DesktopMonitor")

For Each obj2 In wmiObjSet2
	curx = obj2.ScreenWidth
	cury = obj2.ScreenHeight
	Exit For
Next
if verbose Then Wscript.echo "Current resolution is " & curx & "x" & cury & ". Required resolution " & xres & "x" & yres & ". Operation mode " & opmode

if curx = xres And cury = yres Then
	if verbose Then Wscript.echo "Resolution already correct"
	wscript.quit
End If

WshShell.RegWrite root & "szdevice", 1, "REG_DWORD"
WshShell.RegWrite root & "szsdevice", secdev, "REG_DWORD"
WshShell.RegWrite root & "szopmode", opmode, "REG_DWORD"
WshShell.RegWrite root & "szx", xres, "REG_DWORD"
WshShell.RegWrite root & "szy", yres, "REG_DWORD"
WshShell.RegWrite root & "szsx", secx, "REG_DWORD"
WshShell.RegWrite root & "szsy", secy, "REG_DWORD"

WshShell.RegWrite root & "szBottom", yres, "REG_DWORD"
WshShell.RegWrite root & "szTop", 0, "REG_DWORD"
WshShell.RegWrite root & "szLeft", 0, "REG_DWORD"
WshShell.RegWrite root & "szRight", xres, "REG_DWORD"
WshShell.RegWrite root & "szsBottom", yres, "REG_DWORD"
WshShell.RegWrite root & "szsTop", 0, "REG_DWORD"
WshShell.RegWrite root & "szsLeft", xres, "REG_DWORD"
WshShell.RegWrite root & "szsRight", xres+secx, "REG_DWORD"

WshShell.RegWrite root & "szrrate", 60, "REG_DWORD"

WshShell.RegWrite root & "szOvlBrightness", &H02ee&, "REG_DWORD"
WshShell.RegWrite root & "szOvlContrast", &H2710&, "REG_DWORD"
WshShell.RegWrite root & "szOvlGamma", &H0001&, "REG_DWORD"
WshShell.RegWrite root & "szOvlHue", &H1388&, "REG_DWORD"
WshShell.RegWrite root & "szOvlSaturation", &H2710&, "REG_DWORD"
WshShell.RegWrite root & "szPriCustomScaleX", 0, "REG_DWORD"
WshShell.RegWrite root & "szPriCustomScaleY", 0, "REG_DWORD"
WshShell.RegWrite root & "szPriIndependentRoot", 0, "REG_DWORD"
WshShell.RegWrite root & "szPriInterlaces", 0, "REG_DWORD"
WshShell.RegWrite root & "szPriTvFullScreen", 0, "REG_DWORD"
WshShell.RegWrite root & "szPriTvStandard", 0, "REG_DWORD"
WshShell.RegWrite root & "szPriTVType", 0, "REG_DWORD"
WshShell.RegWrite root & "szSecCustomScaleX", 0, "REG_DWORD"
WshShell.RegWrite root & "szSecCustomScaleY", 0, "REG_DWORD"
WshShell.RegWrite root & "szSecIndependentRoot", 0, "REG_DWORD"
WshShell.RegWrite root & "szSecInterlaces", 0, "REG_DWORD"
WshShell.RegWrite root & "szSecTvFullScreen", 0, "REG_DWORD"
WshShell.RegWrite root & "szSecTvStandard", 0, "REG_DWORD"
WshShell.RegWrite root & "szSecTVType", 0, "REG_DWORD"
WshShell.RegWrite root & "szresetonexit", 0, "REG_DWORD"
WshShell.RegWrite root & "szrotation", 0, "REG_DWORD"

WshShell.Run "%SYSTEMROOT%\System32\igfxcfg.exe /SchemeName:" & scheme,0,1
WshShell.RegDelete(root)

Set WshShell = Nothing

Function ReadPersonality(key)
	Dim preg
	Dim oFSO
	Set oFSO = CreateObject("Scripting.FileSystemObject")

	If Not oFSO.FileExists("C:\Program Files\Citrix\Provisioning Services\GetPersonality.exe") Then Exit Function
		
	preg = userkey & "\Software\Citrix\ProvisioningServices\ReadPersonality"
	On Error resume Next
	WshShell.RegDelete(preg)
	On Error Goto 0
	cmd = """C:\Program Files\Citrix\Provisioning Services\GetPersonality.exe""" & " " & key & " /r=" & preg
'	wscript.echo cmd
	WshShell.Run cmd,0,1
	ReadPersonality = WshShell.RegRead(preg)
	If verbose Then Wscript.echo "Personality " & key & "=" & ReadPersonality
End Function
